<?php
/*
 * oct_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    Philipp Hgelmeyer
 * @copyright XXX
 * @abstract
 */
class oct_exercise extends Exercise {

//    var       $g_ExerciseName         = "Octave Text Exercise";
//      var     $g_ExerciseDescription  = "DescriptionExerciseOC";
//      var     $g_reset        = FALSE;
//
    function oct_exercise($xml = null)
    {
        parent::Exercise($xml);

        $this->type = 'oct_exercise';

        if (!isset($xml)) {     // construct exercise using request parameters
            $this->answerArray = array(vips_get_string_param('answer_0', true));
        } else {                // construct exercise using xml
            $this->answerArray     = $this->getTagsFromXML($xml, 'Answer');
            $this->numberOfAnswers = 1;
        }
    }

    /**************************************************************************/
    /*
    /* Evaluates the solution
    /*
    /**************************************************************************/

    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */

    function evaluate($exercise,$solution) {
        // get the xml representation
        global $auth;
        $m_shell_output = "";
        $punkte = 0;
        if (!$dom_aufgabe = domxml_open_mem(utf8_encode($exercise)))
        {
            echo "Error while parsing the document\n";
            exit;
        }
        if (!$dom_loesung = domxml_open_mem(utf8_encode($solution)))
        {
            echo "Error while parsing the document\n";
            exit;
        }
        $m_return[1] = 0; // score
        $m_return[2] = 0; // safe
        $m_return['percent'] = 0;
        $m_return['safe']    = 0;
        return $m_return;
    }



    function downloadSolution ($p_exercise_id
        , $p_exercise_sheet_id
        , $p_exerciseXML
        , $p_exercise_name
        , $p_solutionXML            = ""
        , $p_exercise_solution_id   = ""
        , $p_student_comment        = ""
        , $p_correct        = FALSE)
    {
        $p_solution = vips_get_unquoted_string_param("solution", true);

        $tmpfname = tempnam ("/tmp", $p_exercise_name);

        $handle = fopen($tmpfname, "w");
        fwrite($handle, $p_solution);
        fclose($handle);

        if (!copy($tmpfname, dirname(__FILE__).'/download/'.$p_exercise_name.'.prolog')) {
            print ("failed to copy $tmpfname...<br>\n");
        }
        else {
            $out .= "<a href=\"vips/download/$p_exercise_name.prolog\">$p_exercise_name.prolog zum Download</a>";
        }
        // copy tmpfile to a directory, where it can be downloaded.
        // the problem is to delete the file afterwards.

        unlink($tmpfname);
        $out .= $this->printFormToGetAnswer($p_exercise_id      // old: genOutput
            , $p_exercise_sheet_id
            , $p_exerciseXML
            , $p_exercise_name
            , $p_solutionXML
            , $p_exercise_solution_id
            , $p_student_comment);
        return $out;
    }



    function uploadSolution($p_exercise_id
        , $p_exercise_sheet_id
        , $p_exerciseXML
        , $p_exercise_name
        , $p_solutionXML          = ""
        , $p_exercise_solution_id = ""
        , $p_student_comment      = ""
        , $p_correct        = FALSE)
    {
        global $g_exercise_former_solution;
        if (is_uploaded_file($_FILES['userfile']['tmp_name'])) {
            // note: this is broken for octave exercises
            $g_solution = file_get_contents($_FILES['userfile']['tmp_name']);
        } else {
            $out .=  "Upload failed!";
        }
        //echo $g_exercise_former_solution;
        $out .= $this->printFormToGetAnswer($p_exercise_id      // old: genOutput
            , $p_exercise_sheet_id
            , $p_exerciseXML
            , $p_exercise_name
            , $p_solutionXML
            , $p_exercise_solution_id
            , $p_student_comment);
        return $out;
    }



    /****************************************************************************************/
    /* Queries the query inserted by the student with the corresponding code of the exercise.
    /* @param int exercise_id the id of the exercise that sould be queried.
    /* @param string exerciseXML the exercise code containing the info about the exercise
    /****************************************************************************************/

    /* FIXME: This code is completely broken (needs to be adapted to new API)! */

    function evaluateQuery($p_exercise_id
        , $p_exercise_sheet_id
        , $p_exerciseXML
        , $p_exercise_name
        , $p_solutionXML          = ""
        , $p_exercise_solution_id = ""
        , $p_student_comment      = ""
        , $p_reset                = FALSE
        , $p_correct              = FALSE)
    {
        global $auth, $g_reset;
        $m_number = vips_get_int_param("number");
        $p_solution = vips_get_unquoted_string_param("solution", true);
        if (!$m_number) {
            $m_number = 1;
        } else if ($p_reset) {
            $g_reset = $p_reset;
            $m_number = 1;
        } else {
            $g_reset = $p_reset;
            $m_number++;
        }

        $m_user_id =  $auth->auth['uid'];
        $m_query = vips_get_unquoted_string_param("query", true);
        if ($p_correct) {
            $m_out .= $this->genCorrection($p_exercise_id   // old: genOutput
                , $p_exercise_sheet_id
                , $p_exerciseXML
                , $p_exercise_name
                , $p_solutionXML
                , $p_exercise_solution_id
                , $p_student_comment
                , $p_solution);
        } else {
            $m_out .= $this->printFormToGetAnswer($p_exercise_id   // old: genOutput
                , $p_exercise_sheet_id
                , $p_exerciseXML
                , $p_exercise_name
                , $p_solutionXML
                , $p_exercise_solution_id
                , $p_student_comment);
        }

        /**********************************************************************/
        /* Instead of calling these shell commands directly, this will now be
        /* done by a Prolog Server Remote. Advantage: No Prolog system needs to
        /* be installed locally
        /**********************************************************************/

        $m_shell_output = "";
        $fp = fsockopen("mvc.ikw.uni-osnabrueck.de", 2213, $errno, $errstr, 30);
        if (!$fp) {
            echo "$errstr ($errno)<br />\n";
        } else {
            $out = "<octave>\n<user>\n$m_user_id\n</user>\n<number>\n$m_number\n</number>\n<type>\ntextq\n</type>\n<exercise>\n".$p_solution."\n</exercise>\n</octave>\n";

            fputs($fp, $out);
            while (!feof($fp)) {
                $m_shell_output .= fgets($fp);
            }
            fclose($fp);
        }
        $m_out .= $m_shell_output;
        return $m_out;
    }



    /**************************************************************************/
    /*
    /* XML-generating routines
    /*
    /**************************************************************************/



    /**
     * Generates generates an XML-String containing the solution of the
     * student.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @param int $exercise_id the id of the exercise the solution related to.
     * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
     * @return XML the XML-String containing the solutions of the student.
     *
     * @todo names of the exml entities are not well choosen. A change will have
     * impact on other parts of the code, of course.
     */

    function genSolution($p_exercise_id, $p_number_of_answers = null) {

        $i    = 0;
        $msg  = "<solution id=\"".$p_exercise_id."\">";
        // the choosen answers are in the get or post environment: 1. Otherwise:0.
        $msg .= "<answer id=\"".$i."\">";
        $msg .= "<body>".htmlspecialchars(vips_get_string_param("solution", true))."</body>";
        $msg .= "</answer>";

        $msg .= "</solution>";
        return vips_filter_xml_string($msg);
    }



    /**
     * Generate the description af an exercise in an XML-String.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @return XML the SML-String describing the exercise in terms of its
     * name, questions, worng and correct solutions etc.
     */

    function getExerciseConstruct() {

        /*************************************************************************/
        /* Get data
        /*************************************************************************/

        $m_exercise_language = "de";
        $m_exercise_type     = vips_get_string_param("exercise_type");
        $m_exercise_question = vips_get_string_param("exercise_question", true);
        $m_exercise_name     = vips_get_string_param("exercise_name", true);
        $m_exercise_hint     = vips_get_string_param("exercise_hint", true);
        $m_exercise_comment  = vips_get_int_param("exercise_comment");

        $m_exercise_pic_url  = vips_get_string_param("exercise_pic_url");
        $m_provides          = vips_get_string_param("provides");
        $m_depends           = vips_get_string_param("depends");
        $m_optional_depends  = vips_get_string_param("optional_depends");

        $m_exercise_answer   = vips_get_string_param("answer_0", true);

        $counter             = 1;



        /*************************************************************************/
        /* Construct XML
        /*************************************************************************/

        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"MultipleChoice\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        // In this special Case the hint is displayed inside a textbox to provide comments
        // and code fragments to the student.
        $xmlop .= "<Hint>".htmlspecialchars($m_exercise_hint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_pic_url)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";
        $xmlop .= "<Answer>".htmlspecialchars($m_exercise_answer)."</Answer>";
        $xmlop .= "</TestItem>";

        /*************************************************************************/
        /* Return XML
        /*************************************************************************/

        return vips_filter_xml_string($xmlop);
    }

    /**
     * Export this exercise to plain text format.
     */
    function exportText ()
    {
        $result = parent::exportText('OCT-Frage');

        $answer_text = $this->answerArray[0];

        if ($answer_text != '')
        {
            $result .= "Antwort:\n";
            $result .= $answer_text."\n";
            $result .= "\\Antwort\n";
        }

        return $result;
    }



    /** Creates a template for editing an oct_exercise.
     *
     * @returns The template for editing this exercise
     */
    function getEditTemplate()
    {
        global $vipsTemplateFactory;

        $template = $vipsTemplateFactory->open('exercises/edit_oct_exercise');
        $template->set_attributes(array(
            'answer_array' => $this->getAnswerArray()));

        return $template;
    }
}
?>
