<?

require_once('VipsOutlet.class.php');

/**
 * class VipsOutletStudip
 * Contains Stud.IP-specific information
 *
 * @author: Christa Deiwiks <cdeiwiks@uos.de>
 *
 */

class VipsOutletStudip extends VipsOutlet {

        /**
         * Constructor
         */
        function VipsOutletStudip($name) {
                parent::VipsOutlet($name);
        }

        /**
         * Gets the Stud.IP-ID (md5 hash) of the current user
         */
        function getUserID() {
                global $auth;
                $this->userID = $auth->auth["uid"];
        }

        /**
         * Gets the status [lecturer|tutor|student|nobody] of the current user in the current course
         * depending on Stud.IP Rechte for the current course
         */
        function getStatus() {
                global $perm;
                        if ($perm->have_studip_perm("dozent",$this->courseID)
                         || $perm->have_studip_perm("admin",$this->courseID)
                         || $perm->have_studip_perm("root",$this->courseID))
                        {
                                $this->status = 'lecturer';
                        }
                        elseif ($perm->have_studip_perm("tutor",$this->courseID))
                        {
                                $this->status = 'tutor';
                        }
                        elseif ($perm->have_studip_perm("autor",$this->courseID))
                                $this->status = 'student';
                        else
                                $this->status = 'nobody';

        }
    function logout() {
    }
    function connect() {
    }
        function register_studip() { //not used
        $this->getUserID();
    }
}

?>
