<?php
/*
 * vips_wiki.php - Vips cookbook for PmWiki
 * Copyright (c) 2008  Elmar Ludwig
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

$HTMLStylesFmt[] = '.vips table, .vips td { border: none !important; }';
$HTMLStylesFmt[] = '.vips_title { font-weight: bold; }';

Markup('vips', '<toc', '/\(:vips\s+(\d*)\s*,\s*(\d*):\)/e', "Keep(vips_wiki_show('\$1','\$2'))");
Markup('vips_id', '<toc', '/\(:vips\s+(\d*):\)/e', "Keep(vips_wiki_show_id('\$1'))");

$vips_language = $wiki_language == 'en' ? 'en_GB' : 'de_DE';

$page_group = PageVar($pagename, '$Group');
$page_name = PageVar($pagename, '$Name');
vips_read_config($SiteGroup.'.VipsConfig');
vips_read_config($page_group.'.VipsConfig');

function vips_strip_magic ($value)
{
    if (get_magic_quotes_gpc()) {
        if (is_array($value)) {
            foreach ($value as $key => $val) {
                $value[$key] = vips_strip_magic($val);
            }
        } else {
            $value = stripslashes($value);
        }
    }

    return $value;
}

function vips_read_config ($pagename)
{
    global $vips_url;

    $page = ReadPage($pagename);

    if ($page) {
        $text = explode("\n", $page['text']);

        foreach ($text as $line) {
            if (preg_match('/\bvips_url\s*=\s*(\S*)/', $line, $match)) {
                $vips_url = $match[1];
            }
        }
    }
}

function vips_curl_get ($url, $params)
{
    foreach ($params as $key => $value) {
        $query .= empty($query) ? '?' : '&';
        $query .= urlencode($key).'='.urlencode($value);
    }

    $handle = curl_init($url.$query);

    curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);

    $result = curl_exec($handle);
    $error = curl_error($handle);
    curl_close($handle);

    return $error === '' ? ($result === true ? '' : $result) : $error;
}

function vips_curl_post ($url, $params)
{
    $handle = curl_init($url);

    curl_setopt($handle, CURLOPT_POST, true);
    curl_setopt($handle, CURLOPT_POSTFIELDS, http_build_query($params));
    curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);

    $result = curl_exec($handle);
    $error = curl_error($handle);
    curl_close($handle);

    return $error === '' ? ($result === true ? '' : $result) : $error;
}

function vips_wiki_show ($assignment_id, $exercise_position)
{
    global $FarmID, $FieldDir, $vips_url, $vips_language;

    if ($_REQUEST['assignment_id'] == $assignment_id &&
        $_REQUEST['exercise_position'] == $exercise_position) {

        $params = array(
            'subaction' => 'submit',
            'system_id' => $FarmID,
            'module_id' => $FieldDir,
            'language'  => $vips_language,
            'solver_id' => $_SESSION['authid'][0]
        );

        $params += vips_strip_magic($_POST);

        $result = vips_curl_post($vips_url, $params);
    }

    $params = array(
        'subaction' => 'show',
        'system_id' => $FarmID,
        'module_id' => $FieldDir,
        'language'  => $vips_language,
        'assignment_id' => $assignment_id,
        'exercise_position' => $exercise_position,
        'solver_id' => $_SESSION['authid'][0]
    );

    $result .= vips_curl_get($vips_url, $params);

    return $result;
}

function vips_wiki_show_id ($exercise_id)
{
    global $FarmID, $FieldDir, $vips_url, $vips_language;

    if ($_REQUEST['exercise_id'] == $exercise_id) {

        $params = array(
            'subaction' => 'submit',
            'system_id' => $FarmID,
            'module_id' => $FieldDir,
            'language'  => $vips_language,
            'solver_id' => $_SESSION['authid'][0]
        );

        $params += vips_strip_magic($_POST);

        $result = vips_curl_post($vips_url, $params);
    }

    $params = array(
        'subaction' => 'show',
        'system_id' => $FarmID,
        'module_id' => $FieldDir,
        'language'  => $vips_language,
        'exercise_id' => $exercise_id,
        'solver_id' => $_SESSION['authid'][0]
    );

    $result .= vips_curl_get($vips_url, $params);

    return $result;
}
?>
