<?php
$counter = 0;

// show sample solution and correction (used after selftest, under correction and when the student is viewing the correction)
if ($show_solution && (!$print || $samplesolution)) {
    $colspan = 6;
    $col_width = array(40, 40, 10, 10);
}

// show sample solution without correction (only used in print view)
else if ($print && $samplesolution && !$korrektur) {
    $colspan = 5;
    $col_width = array(45, 45, 10);
}

// show form for student to solve the exercise
else {
    $colspan = 4;
    $col_width = array(50, 50);
}
?>

<!-- start template show_rh_exercise -->

<script language="JavaScript" type="text/javascript">
    <!--
    updateOptions(); // run it once as the side is loaded
    function updateOptions()
    {
        var selects = document.getElementsByName("student_answer[]");
        var options = document.getElementsByName("option");

        for (var i = 0; i < options.length; i++)
        {
            options[i].style.color = "";
        }

        for (var i = 0; i < selects.length; i++)
        {
            for (var j = 0; j < options.length; j++)
            {
                if (options[j].value == selects[i].value)
                {
                    options[j].style.color = "red";
                }
            }
        }
    }
    // -->
</script>



<div class="vips_steel" style="padding-bottom: 1em;">
    <?= formatReady($exercise_question) ?>
</div>

<? if ($exercise_hint) : ?>
    <?= $this->render_partial('exercises/show_exercise_hint') ?>
<? endif ?>



<table class="vips" style="width: 100%;">

    <? /* table header */ ?>
    <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution)) : ?>
        <tr class="vips_tbl_hdr">
            <? /* default text */ ?>
            <td class="vips" colspan="2" style="width: <?=$col_width[0]?>%; vertical-align: middle;">
                <?=_("vorgegebener Text")?>
            </td>

            <? /* answer to assign */ ?>
            <td class="vips" colspan="2" style="width: <?=$col_width[1]?>%; vertical-align: middle;">
                <?=_("zuzuordnender Text")?>
            </td>

            <? /* correct answer */ ?>
            <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution)) : ?>
                <td class="vips" style="width: <?=$col_width[2]?>%; text-align: center; vertical-align: middle;">
                    <?=_("richtige Antwort")?>
                </td>
            <? endif ?>

            <? /* correct */ ?>
            <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution && $korrektur)) : ?>
                <td class="vips" style="width: <?=$col_width[3]?>%; text-align: center; vertical-align: middle;">
                    <?=_("korrekt")?>
                </td>
            <? endif ?>
        </tr>
        <tr><td class="vips_tbl_edg" colspan="<?=$colspan?>"></td></tr>
    <? endif ?>

    <? /* process default array */ ?>
    <? for ($i = 0; $i < count($quirks['default_array']); $i++) : ?>
        <tr class="vips_tbl_cnt<?=$counter++%2+1?>">
            <? /* number */ ?>
            <td class="vips" style="width: 1%; text-align: right; vertical-align: center;">
                <?= $i+1 ?>.
            </td>

            <? /* default */ ?>
            <td class="vips">
                <?= formatReady($quirks['default_array'][$i]) ?>
            </td>

            <? /* answer */ ?>
            <td class="vips" style="width: 1%; text-align: right; white-space: nowrap;">
                <? /* student can solve via select box */ ?>
                <? if (!$print && !$korrektur && !$show_solution) : ?>
                    (<?=_("zu")?>&nbsp;
                    <select name="student_answer[]" onChange="updateOptions();">
                        <option value="NULL">
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </option>
                        <? for ($j = 0; $j < count($answer_array); $j++) : ?>
                            <option name="option" value="<?=$j?>" size="4"<? if (isset($student_array[$i]) && $student_array[$i] == $j && $student_array[$i] != "NULL") : ?> selected<? endif ?>>
                                <?=$j+1?>
                            </option>
                        <? endfor ?>
                    </select>)

                <? /* print view with sample solution */ ?>
                <? elseif (!$print || $show_solution) : ?>
                    (<?= _("zu") ?>&nbsp;__<span style="font-style: italic; text-decoration: underline;"><?= isset($student_array[$i]) ? $student_array[$i] + 1 : '&ndash;' ?></span>__)

                <? /* just print line */ ?>
                <? else : ?>
                    (<?=_("zu")?>&nbsp;______)
                <? endif ?>
            </td>
            <td class="vips" style="width: 45%;">
                <?= formatReady($answer_array[$i]) ?>
            </td>

            <? /* correct answer */ ?>
            <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution)) : ?>
                <td class="vips" style="text-align: center;">
                    <?=$correct_array[$i]+1?>
                </td>
            <? endif ?>

            <? /* correct */ ?>
            <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution && $korrektur)) : ?>
                <td class="vips" style="text-align: center; vertical-align: middle;">
                    <? if (!isset($student_array[$i])) : ?>
                        &ndash;
                    <? elseif ($student_array[$i] == $correct_array[$i]) : ?>
                        <img src="<?=$picturepath?>haken_transparent.gif" alt="">
                    <? else : ?>
                        <img src="<?=$picturepath?>x_transparent.gif" alt="">
                    <? endif ?>
                </td>
            <? endif ?>
        </tr>
    <? endfor ?>

    <? /* bottom edge */ ?>
    <? if ((!$print && ($show_solution || $korrektur)) || ($print && $samplesolution)) : ?>
        <tr><td class="vips_tbl_edg" colspan="<?=$colspan?>"></td></tr>
    <? endif ?>

</table>



<div class="vips_steel" style="height: 1em;">
</div>



<script language="JavaScript" type="text/javascript">
    <!--
    updateOptions(); // run it once when the page is loaded
    // -->
</script>

<!-- end of template show_rh_exercise -->
